#!/usr/bin/perl -X
# PP=/sciezka/do/skryptu/; PERL5LIB=$PP perl $PP/mtr.pl && chown -R www-data $PP/* && chgrp -R www-data $PP/*

use Config::IniFiles;	# aptitude install libconfig-inifiles-perl
use Data::Dumper;
use Getopt::Long;
use Time::Local;
use POSIX qw/strftime/;


 my $p_name = "MtrStatistics";
 my $p_version = "1.0.0.PL";
 my $p_data = "19.01.2015";
 my $p_lang = "pl_PL";

 my %options = (
	"--quiet|q"		=>	\my $argQuiet,
	"--help|h|?"	=>	\my $argHelp,
	"--version|v"	=>	\my $argVersion,
	"--kill:i"		=>	\my $argKill,
 );
 Getopt::Long::config("no_ignore_case");
 GetOptions(%options);

   if($argHelp){
	print " $p_name, version $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print "\n";
	print "-q, -?, --quiet	tłumi drukowanie dane na wyjściu; error, done\n";
	print "-h,     --help		drukuje pomoc\n";
	print "-v,     --version	drukuje wersje\n";
	print "        --kill=30	ubija wcześniej uruchomiony skrypt, który żyje dłużej niż określony czas   (default: 30min)\n";
	print "\n";
	exit 0;
   }

   if($argVersion) {
	print " $p_name, drukuje wersje $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print " strona: http://kazuko.pl\n";
	print "\n";
	exit 0;
   }

  ## ubijanie procesów które żyją dłużej niż .. min
   if($argKill eq "0") { killprog($0, 30); } elsif($argKill) { killprog($0, $argKill); }

my $count = 10;

my $hostINI = new Config::IniFiles -file => path("./hosts.ini");
print @Config::IniFiles::errors;
my $confINI = new Config::IniFiles -file => path("./config.ini");
print @Config::IniFiles::errors;

my $time = strftime('%d.%m.%Y_%H:%M:%S',localtime);


   foreach my $li ($hostINI->Sections()) {
	my @arr = $hostINI->{v}{$li};
	my $host = $li;
	my $name = @arr->[0]{'name'};
	my $fullpath = delHash($confINI->val("path", "mtrDIR"))."/".$host;

	   if(!$argQuiet) { print $host."\t".$name."\n"; }
	   if(!(-d $fullpath)) { mkdir($fullpath, 0700); }


	my $pam = 0;
	my $save = "";
	open (PING, "ping -nqc 1 $host|");
	   while (<PING>) {
		/\((\d+\.\d+\.\d+\.\d+)\)/ && ($ip = $1);
	   };
	close (PING);
	open(MTR, "mtr --report --no-dns --report-cycles $count $ip|"); my @mtr = <MTR>; close (MTR); 



	   foreach my $out (@mtr) {
		my $ip = "";
		my $proc = "";
		my $hostx = "";
		$out =~ s/\s+$//;
		$out =~ m/(\d+\.\d+\.\d+\.\d+)/; $ip = $1;
		$out =~ m/(\d+\.\d+\%)/; $proc = $1;
		   if($ip and $proc =~ /^\d+\.\d+\%$/) {
			open (HOST, "host $ip|"); while (<HOST>) { /domain name pointer (.+)\.$/ && ($hostx = $1); }; close (HOST);
			$save .= $out."\t ".$hostx."\n";
		   } elsif($ip and !($proc =~ /^\d+\.\d+\%$/)) {
			open (HOST, "host $ip|"); while (<HOST>) { /domain name pointer (.+)\.$/ && ($hostx = $1); }; close (HOST);
			$save .= $out."\t\t\t\t\t\t\t   ".$hostx."\n";
		   } elsif($pam eq 0) {
			$save .= $out."\tDomain/Host\n";
			$pam = 1;
		   } else {
			$save .= $out."\n";
		   }
	   }

	open(UCHWYT, '>', $fullpath."/".$host."_".$time.".txt"); 
	print UCHWYT $save; 
	close UCHWYT; 
   }








sub delHash { 
 my($tekst) = @_; 
 $tekst =~ s/(#|;)(.*)$//g;
 return trim($tekst);
}

sub trim($) {
 my $string = shift;
 $string =~ s/^\s+//;
 $string =~ s/\s+$//;
 return $string;
}


# killprog("x.pl", 60);
sub killprog {
   my($nprog, $life) = @_;
   my @lists = qx(ps -aux 2> /dev/null | grep '$nprog' );

   foreach my $out (@lists) { if(!($out =~ /^.*grep.*$/)) {
	$out = trim($out);
	my @tab = split(/\s+/, $out);
	my @tim = split(/\:/, @tab[9]);
	   if(@tim[0] > $life) {
		system("kill -9 ".@tab[1]." 1> /dev/null 2> /dev/null");	
	   }
   }}

 return 1;
}



sub path { 
 my($path) = @_; 
 my $pwd = trim(gdzieScript($0)) || trim(cwd)."/";
 my $domowy = qx(echo \$HOME); $domowy = trim($domowy);

 $path =~ s/^\~\//$domowy\//g;
 $path =~ s/^\.\//$pwd/g;

 return $path; 
}

sub gdzieScript {
 my($polecenie) = @_;
  my @tab = split(/\//, $polecenie);
  my $ileTAB =  @tab;
  $polecenie =~ s/@tab[$ileTAB-1]//g;
 return trim($polecenie);
}



sub delHash { 
 my($tekst) = @_; 
   if($tekst =~ /^".+".*$/) {
	 $tekst =~ s/"\s*(#|;)(.*)$//g;
   } else {
	 $tekst =~ s/\s*(#|;)(.*)$//g;
   }
 $tekst =~ s/^\s+//;
 $tekst =~ s/\s+$//;
 $tekst =~ s/^"//g;
 $tekst =~ s/"$//g;
 $tekst =~ s/^'//g;
 $tekst =~ s/'$//g;
 return $tekst;
}
