#!/usr/bin/perl -X
# PP=/sciezka/do/skryptu/; PERL5LIB=$PP perl $PP/mtr.pl && chown -R www-data $PP/* && chgrp -R www-data $PP/*

use Config::IniFiles;	# aptitude install libconfig-inifiles-perl
use Data::Dumper;
use RRDs;			# aptitude install librrdtool-oo-perl
use Getopt::Long;
use Time::Local;
use POSIX qw/strftime/;


 my $p_name = "PingStatistics";
 my $p_version = "1.0.0.PL";
 my $p_data = "19.01.2015";
 my $p_lang = "pl_PL";

 my %options = (
	"--quiet|q"		=>	\my $argQuiet,
	"--help|h|?"	=>	\my $argHelp,
	"--version|v"	=>	\my $argVersion,
	"--kill:i"		=>	\my $argKill,

	"--wykresy|w"	=>	\my $argWykresy,
 );
 Getopt::Long::config("no_ignore_case");
 GetOptions(%options);

   if($argHelp){
	print " $p_name, version $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print "\n";
	print "-q, -?, --quiet	tłumi drukowanie dane na wyjściu; error, done\n";
	print "-h,     --help		drukuje pomoc\n";
	print "-v,     --version	drukuje wersje\n";
	print "        --kill=30	ubija wcześniej uruchomiony skrypt, który żyje dłużej niż określony czas   (default: 30min)\n";
	print "\n";
	print "-w,     --wykresy	czy ma generowac wykresy img\n";
	print "\n";
	exit 0;
   }

   if($argVersion) {
	print " $p_name, drukuje wersje $p_version [$p_data]\n";
	print " autor: seszu (seba\@kazuko.pl)\n";
	print " strona: http://kazuko.pl\n";
	print "\n";
	exit 0;
   }

  ## ubijanie procesów które żyją dłużej niż .. min
   if($argKill eq "0") { killprog($0, 30); } elsif($argKill) { killprog($0, $argKill); }

my $hostINI = new Config::IniFiles -file => path("./hosts.ini");
print @Config::IniFiles::errors;
my $confINI = new Config::IniFiles -file => path("./config.ini");
print @Config::IniFiles::errors;

my $rrdDIR = delHash($confINI->val("path", "rrdDIR"));
my $imgDIR = delHash($confINI->val("path", "imgDIR"));
my $count = 2;
my $coIle = 120;

   foreach my $li ($hostINI->Sections()) {
	my @arr = $hostINI->{v}{$li};
	my $host = $li;
	my $name = @arr->[0]{'name'};
	my $hostx = "";

	   if(!$argQuiet) { print $host."\t".$name."\t"; }

	open (PING, "ping -nqc $count $host|");
	   while (<PING>) {
		/\((\d+\.\d+\.\d+\.\d+)\)/ && ($ip = $1);
		/(\d+)% packet loss/ && ($loss = $1);
		/= (.+)\/(.+)\/(.+)\/(.+) ms/ && (($min,$avg,$max,$mdev) = ($1,$2,$3,$4));
	   };
	close (PING);
	open (HOST, "host $ip|");
	   while (<HOST>) {
		/domain name pointer (.+)\.$/ && ($hostx = $1);
	   };
	close (HOST);


	   if(!-e $rrdDIR."/$host-ping.rrd") {
		RRDs::create($rrdDIR."/$host-ping.rrd",
				"-s ".$coIle,
				"DS:min:GAUGE:720:0:U",
				"DS:avg:GAUGE:720:0:U",
				"DS:max:GAUGE:720:0:U",
				"RRA:AVERAGE:0.5:1:262800",
				"RRA:MAX:0.5:1:5",
				"RRA:LAST:0.5:1:600"
		);
	   }

	RRDs::update( $rrdDIR."/$host-ping.rrd","N:$min:$avg:$max");

	   if(!-e $rrdDIR."/$host-loss.rrd") {
		RRDs::create($rrdDIR."/$host-loss.rrd",
				"-s ".$coIle,
				"DS:loss:GAUGE:720:0:U",
				"RRA:AVERAGE:0.5:1:262800",
				"RRA:MAX:0.5:1:5",
				"RRA:LAST:0.5:1:600"
		);
	   }

	RRDs::update($rrdDIR."/$host-loss.rrd","N:$loss");





	   if($argWykresy) {
		   if(!$argQuiet) { print "wykres\n"; }

		## PING
		RRDs::graph($imgDIR."/$host-hour-ping.png",
				"-s -".(1*60*60),
				"-w 875",
				"-h 250",
				"--title=ping do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnia godzina",
				"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
				"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
				"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
				"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

				"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
				"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

				"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
				"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",
		);
		RRDs::graph($imgDIR."/$host-day-ping.png",
				"-s -".(24*(1*60*60)),
				"-w 875",
				"-h 250",
				"--title=ping do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 24h",
				"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
				"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
				"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
				"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

				"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
				"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

				"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
				"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

		);
		RRDs::graph($imgDIR."/$host-week-ping.png",
				"-s -".(7*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=ping do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 7 dni",
				"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
				"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
				"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
				"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

				"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
				"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

				"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
				"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

		);
		RRDs::graph($imgDIR."/$host-30_days-ping.png",
				"-s -".(30*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=ping do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 30 dni",
				"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
				"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
				"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
				"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

				"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
				"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

				"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
				"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

		);
		RRDs::graph($imgDIR."/$host-year-ping.png",
				"-s -".(365*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=ping do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 365 dni",
				"DEF:min=".$rrdDIR."/$host-ping.rrd:min:AVERAGE",
				"DEF:avg=".$rrdDIR."/$host-ping.rrd:avg:AVERAGE",
				"DEF:max=".$rrdDIR."/$host-ping.rrd:max:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:min:MAX:%7.2lf%sms", "GPRINT:min:AVERAGE:%7.2lf%sms", "GPRINT:min:MIN:%7.2lf%sms", "GPRINT:min:LAST:%7.2lf%sms",
				"LINE1:min#00CF00FF:min ping \\n", "AREA:min#00CF0033",

				"GPRINT:avg:MAX:%7.2lf%sms", "GPRINT:avg:AVERAGE:%7.2lf%sms", "GPRINT:avg:MIN:%7.2lf%sms", "GPRINT:avg:LAST:%7.2lf%sms",
				"LINE2:avg#005199FF:avg ping \\n", "AREA:avg#00519933",

				"GPRINT:max:MAX:%7.2lf%sms", "GPRINT:max:AVERAGE:%7.2lf%sms", "GPRINT:max:MIN:%7.2lf%sms", "GPRINT:max:LAST:%7.2lf%sms",
				"LINE1:max#FF0101FF:max ping \\n", "AREA:max#FF010133",

		);


		## LOSS
		RRDs::graph($imgDIR."/$host-hour-loss.png",
				"-s -".(1*60*60),
				"-w 875",
				"-h 250",
				"--title=loss do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnia godzina",
				"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
				"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
		);
		RRDs::graph($imgDIR."/$host-day-loss.png",
				"-s -".(24*(1*60*60)),
				"-w 875",
				"-h 250",
				"--title=loss do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 24h",
				"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
				"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
		);
		RRDs::graph($imgDIR."/$host-week-loss.png",
				"-s -".(7*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=loss do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 7 dni",
				"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
				"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
		);
		RRDs::graph($imgDIR."/$host-30_days-loss.png",
				"-s -".(30*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=loss do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 30 dni",
				"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
				"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
		);
		RRDs::graph($imgDIR."/$host-year-loss.png",
				"-s -".(365*(24*(1*60*60))),
				"-w 875",
				"-h 250",
				"--title=loss do $ip ".($hostx ? "- ".$hostx." " : "")."($host) - ostatnie 365 dni",
				"DEF:loss=".$rrdDIR."/$host-loss.rrd:loss:AVERAGE",
				"COMMENT:  Maxymalny    Średni     Minimalny    Ostatni                          wygenerowano ".strftime('%d-%m-%Y %H-%M-%S',localtime(time()))."\\n",

				"GPRINT:loss:MAX:%7.2lf%s", "GPRINT:loss:AVERAGE:%7.2lf%s", "GPRINT:loss:MIN:%7.2lf%s", "GPRINT:loss:LAST:%7.2lf%s",
				"LINE1:loss#FF0101FF:loss [%]\\n", "AREA:loss#FF010133",
		);
	   } else {
		   if(!$argQuiet) { print "\n"; }
	   }
   }




sub delHash { 
 my($tekst) = @_; 
 $tekst =~ s/(#|;)(.*)$//g;
 return trim($tekst);
}

sub trim($) {
 my $string = shift;
 $string =~ s/^\s+//;
 $string =~ s/\s+$//;
 return $string;
}


# killprog("x.pl", 60);
sub killprog {
   my($nprog, $life) = @_;
   my @lists = qx(ps -aux 2> /dev/null | grep '$nprog' );

   foreach my $out (@lists) { if(!($out =~ /^.*grep.*$/)) {
	$out = trim($out);
	my @tab = split(/\s+/, $out);
	my @tim = split(/\:/, @tab[9]);
	   if(@tim[0] > $life) {
		system("kill -9 ".@tab[1]." 1> /dev/null 2> /dev/null");	
	   }
   }}

 return 1;
}


sub path { 
 my($path) = @_; 
 my $pwd = trim(gdzieScript($0)) || trim(cwd)."/";
 my $domowy = qx(echo \$HOME); $domowy = trim($domowy);

 $path =~ s/^\~\//$domowy\//g;
 $path =~ s/^\.\//$pwd/g;

 return $path; 
}

sub gdzieScript {
 my($polecenie) = @_;
  my @tab = split(/\//, $polecenie);
  my $ileTAB =  @tab;
  $polecenie =~ s/@tab[$ileTAB-1]//g;
 return trim($polecenie);
}



sub delHash { 
 my($tekst) = @_; 
   if($tekst =~ /^".+".*$/) {
	 $tekst =~ s/"\s*(#|;)(.*)$//g;
   } else {
	 $tekst =~ s/\s*(#|;)(.*)$//g;
   }
 $tekst =~ s/^\s+//;
 $tekst =~ s/\s+$//;
 $tekst =~ s/^"//g;
 $tekst =~ s/"$//g;
 $tekst =~ s/^'//g;
 $tekst =~ s/'$//g;
 return $tekst;
}
